---
marp: true
title: Markdown and applications
author: P.Y. Barriat
description: Markdown and applications
backgroundImage: url('assets/back.png')
_backgroundImage: url('assets/garde.png')
footer: 02/06/2023 | Markdown and applications | PY Barriat
_footer: ""
paginate: true
_paginate: false
math: true
---

Markdown and applications<!--fit-->
===

https://gogs.elic.ucl.ac.be/pbarriat/learning-markdown

![h:280](assets/logo.png)

**Pierre-Yves Barriat**
ELIC Training Sessions `June 13th, 2023`

---

# What is Markdown ?

Lightweight **markup language** (a *text-encoding system*)

> "Set of symbols inserted in a text document to control its structure, formatting, or the relationship between its parts."

Others markup languages: HTML, LaTeX, etc

Created in 2004, **Markdown** is now one of the world’s most popular markup languages

Markdown is different than using a `WYSIWYG`

---

# Why Markdown ?

- Markdown is for **everything**: websites, documents, notes, books, presentations, email messages, technical documentation

- Markdown is **portable** 
  > MS Word locks your content into a proprietary file format

- Markdown is platform **independent**

- Markdown is **simple** and future proof
  > so easy to learn ( $\neq$ LaTeX)

- Markdown is **everywhere** : Reddit, GitHub, readme, etc

---

# Live Demo

Several online Markdown editors to try writing in Markdown

For example, try [Dillinger](https://dillinger.io/)

After you've become familiar with Markdown, you may want to use a Markdown application that can be installed on your computer

---

# Prerequisites

- text editor : [Visual Studio Code](https://code.visualstudio.com/download)

- universal document converter : [Pandoc](https://pandoc.org/installing.html)

- TeX distribution : [LaTeX](https://www.latex-project.org/)

- Markdown presentation ecosystem : [Marp](https://marp.app/)

---

## Visual Studio Code

VSC is one of the most popular and powerful text editors used by software engineers today 
> free and available for [macOS](https://www.youtube.com/watch?v=8CJXB4Nu1wo), [Windows](https://www.youtube.com/watch?v=AdeWO-n9O2Q) and [Linux](https://code.visualstudio.com/download)

### You didn't already install VS Code ?

Take a look here
https://gogs.elic.ucl.ac.be/pbarriat/learning-vscode

---

### VS Code in WSL

Open a **Powershell terminal** in **Administrator mode** and do

```sh
wsl --update
```

Open the **Ubuntu terminal** and do

```bash
sudo apt update
sudo apt upgrade
sudo apt install gedit -y
sudo apt install chromium-browser -y
```

---

### VS Code in Ubuntu

Open the **terminal** and do

```bash
sudo apt update
sudo apt upgrade
sudo apt install chromium-browser -y
```

### VS Code in any case

Open VS Code and install the following extensions

- `Markdown All in One`
- `Marp`

---

## Pandoc

Pandoc is a library for converting from one markup format to another, and a command-line tool that uses this library.
> free and available for macOS, Windows, and Linux
> - [Pandoc](https://github.com/jgm/pandoc/releases)
> - [Pandoc-crossref](https://github.com/lierdakil/pandoc-crossref/releases)

```bash
cd
wget https://github.com/jgm/pandoc/releases/download/3.1.2/pandoc-3.1.2-linux-amd64.tar.gz
wget https://github.com/lierdakil/pandoc-crossref/releases/download/v0.3.16.0/pandoc-crossref-Linux.tar.xz
tar xzf pandoc-3.1.2-linux-amd64.tar.gz
tar -xf pandoc-crossref-Linux.tar.xz
mv pandoc-3.1.2/* .
mv pandoc-crossref bin
mv pandoc-crossref.1 share/man/man1
echo "export PATH=\$PATH:\$HOME/bin" >> .bashrc
echo "export MANPATH=\$MANPATH:\$HOME/share" >> .bashrc
rm -rf pandoc-3.1.2 pandoc-3.1.2-linux-amd64.tar.gz pandoc-crossref-Linux.tar.xz
```

---

## Tex distribution

**LaTeX** is a high-quality typesetting system; it includes features designed for the production of technical and scientific documentation.
> free and available for [macOS](https://www.tug.org/mactex/), [Windows](https://miktex.org/download), and Linux

```bash
sudo apt install -y texlive-latex-base \
                 texlive-latex-recommended \
                 texlive-fonts-recommended \
                 texlive-latex-extra \
                 texlive-fonts-extra \
                 texlive-xetex \
                 texlive-lang-french \
                 texlive-latex-extra
```

---

## Marp

Marp (MarkDown slides extension) can convert **Marp Markdown** files into static HTML/CSS, PDF, PowerPoint document, and image(s) easily

Download and install marp-cli (a **CLI** interface for Marp) from the standalone binaries
> free and [available](https://github.com/marp-team/marp-cli/releases/) for macOS, Windows and Linux
> you must install Chrome, Chromium or Edge

```bash
cd
wget https://github.com/marp-team/marp-cli/releases/download/v2.5.0/marp-cli-v2.5.0-linux.tar.gz
tar xzf marp-cli-v2.5.0-linux.tar.gz
mv marp bin ; rm -f marp-cli-v2.5.0-linux.tar.gz
```

---

## VS Code nice extensions

- `Remote - SSH` : lets you use any remote machine with a SSH server
- `Tabnine` : code faster with AI code completions
- `Regex Previewer` : shows the current regular expression's matches
- `Markdown Preview Enhanced `
- `Markdownlint`

And :

- `Modern Fortran`


---

# My first example: README.md

---

# For my second example, I want slides

---

# Now I want a small document: a letter

---

# A bigger document ? a report maybe ?

---

# My last example: a scientific paper !

